#! /usr/bin/python2

# This is meant to read the USER BUTTON on BeagleBoardxM rev.C which is bound to /dev/input/event0

from evdev import InputDevice, categorize, ecodes
import psutil, time
import subprocess
import wemust
import threading


threads = []

BUTTON_PATH = '/dev/input/event1'
EXECUTABLE_PATH = '/usr/bin/jackaudio.py'
DEBOUNCE_TIME = 1.0 # seconds
MAX_LONG_PRESSURE = 4.0
mode = 'RESET' # alternative: STARTSTOP
#mode = 'STARTSTOP'

def startJ():
    global threads
    global dbgSock
    proc = subprocess.Popen([EXECUTABLE_PATH, 'start'], stdout=subprocess.PIPE, stderr=subprocess.STDOUT, bufsize=-1)
    procDisp = threading.Thread(target=wemust.dispatcherThread, args=(proc.stdout, dbgSock)) # I could put sock.accept in the main and spanw a thread for each connection, but then I would use subprocess.check_output which does not send any data until the child is finished
    threads.append(procDisp)
    procDisp.daemon = True # thread dies with the program
    procDisp.start()

def checkJack():
    # a bit slow, maybe Popen(ps aux | grep jackd) could be faster
    for proc in psutil.process_iter():
        if proc.name.find("jackd") != -1: # found
            return 1
    return 0

## MAIN ##
dev = InputDevice(BUTTON_PATH)
dbgSock = wemust.wInit()
JACK_ON = checkJack() # for compatibility with STARTSTOP mode

if mode == 'RESET':
    mark = 0 # event value for pressed button = 1, depressed = 0
    for event in dev.read_loop():
        if event.type == ecodes.EV_KEY: # keypress, the USRBUTTON corresponds to type 1, code 276
            if mark == 0:
                mark = event.sec + event.usec * 1e-6
            else:
                diff = (event.sec + event.usec * 1e-6) - mark
                mark = 0
                if diff < DEBOUNCE_TIME:
                    if checkJack(): # JACK already active
                        wemust.dbg_print("RESTART JACK")
                        subprocess.Popen([EXECUTABLE_PATH, 'stop'])
                        #try:
                        #    threads.pop().join(2) # timeout
                        #except:
                        #    pass # likely threads is empty and pop returned an exception
                        startJ()
                    else:
                        wemust.dbg_print("START JACK")
                        startJ()

                elif diff > DEBOUNCE_TIME and diff < MAX_LONG_PRESSURE:
                    wemust.dbg_print("STOP JACK")
                    subprocess.Popen([EXECUTABLE_PATH, 'stop'])
                    try:
                        threads.pop().join(2) # timeout
                    except:
                        pass # likely threads is empty and pop returned an exception

elif mode == 'STARTSTOP':
    mark = 0 # event value for pressed button = 1, depressed = 0
    for event in dev.read_loop():
        if event.type == ecodes.EV_KEY: # keypress, the USRBUTTON corresponds to type 1, code 276
            if mark == 0:
                mark = event.sec + event.usec * 1e-6
            else:
                diff = (event.sec + event.usec * 1e-6) - mark
                mark = 0
                if diff < DEBOUNCE_TIME:
                    if JACK_ON == 1:
                        wemust.dbg_print("STOPPING JACK")
                        subprocess.Popen([EXECUTABLE_PATH, 'stop'])
                        JACK_ON = 0
                        try:
                            threads.pop().join(2) # timeout
                        except:
                            pass # likely threads is empty and pop returned an exception
                    else:
                        wemust.dbg_print("STARTING JACK")
                        #subprocess.Popen([EXECUTABLE_PATH, 'start'])
                        proc = subprocess.Popen([EXECUTABLE_PATH, 'start'], stdout=subprocess.PIPE, stderr=subprocess.STDOUT, bufsize=-1)
                        procDisp = threading.Thread(target=wemust.dispatcherThread, args=(proc.stdout, dbgSock)) # I could put sock.accept in the main and spanw a thread for each connection, but then I would use subprocess.check_output which does not send any data until the child is finished
                        threads.append(procDisp)
                        procDisp.daemon = True # thread dies with the program
                        procDisp.start()
                        JACK_ON = 1
